Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -905,53 +1207,191 @@
     if nperio in [ 3 , 4 ]  :
         if cd_type in  [ 'T' , 'W' ] :
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix>=2       ), jpj-2, jpi-ix+2)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==1       ), jpj-1, 3       )   
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, ix>=jpi//2+1), jy   , jpi-ix+2) 
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix>=2       ), jpj-2, jpi-ix+2)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==1       ), jpj-1, 3       )
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1, ix>=jpi//2+1),
+                                  jy , jpi-ix+2)
 
         if cd_type in [ 'U' ] :
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , np.logical_and (ix>=1, ix <= jpi-1)   ), jy   , jpi-ix+1)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==1  )                               , jpj-2, 2       )
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==jpi)                               , jpj-2, jpi-1   )
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, np.logical_and (ix>=jpi//2, ix<=jpi-1)), jy   , jpi-ix+1)
-          
+            jy, ix = mod_ij (np.logical_and (
+                      jy==jpj  ,
+                      np.logical_and (ix>=1, ix <= jpi-1)   ),
+                                         jy   , jpi-ix+1)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==1  ) , jpj-2, 2       )
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==jpi) , jpj-2, jpi-1   )
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1,
+                            np.logical_and (ix>=jpi//2, ix<=jpi-1)), jy   , jpi-ix+1)
+
         if cd_type in [ 'V' ] :
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, ix>=2  ), jpj-2, jpi-ix+2)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix>=2  ), jpj-3, jpi-ix+2)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==1  ), jpj-3,  3      )
-            
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1, ix>=2  ), jpj-2, jpi-ix+2)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix>=2  ), jpj-3, jpi-ix+2)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==1  ), jpj-3,  3      )
+
         if cd_type in [ 'F' ] :
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, ix<=jpi-1), jpj-2, jpi-ix+1)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix<=jpi-1), jpj-3, jpi-ix+1)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==1    ), jpj-3, 2       )
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==jpi  ), jpj-3, jpi-1   )
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1, ix<=jpi-1), jpj-2, jpi-ix+1)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix<=jpi-1), jpj-3, jpi-ix+1)
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==1    ), jpj-3, 2       )
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==jpi  ), jpj-3, jpi-1   )
 
     if nperio in [ 5 , 6 ] :
         if cd_type in [ 'T' , 'W' ] :                        # T-, W-point
-             (jy, ix) = modIJ (jy==jpj, jpj-1, jpi-ix+1)
- 
+            jy, ix = mod_ij (jy==jpj, jpj-1, jpi-ix+1)
+
         if cd_type in [ 'U' ] :                              # U-point
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix<=jpi-1   ), jpj-1, jpi-ix  )
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix==jpi     ), jpi-1, 1       )
-            
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix<=jpi-1   ), jpj-1, jpi-ix  )
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix==jpi     ), jpi-1, 1       )
+
         if cd_type in [ 'V' ] :    # V-point
-            (jy, ix) = modIJ (jy==jpj                                 , jy   , jpi-ix+1)
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, ix>=jpi//2+1), jy   , jpi-ix+1)
-            
+            jy, ix = mod_ij (jy==jpj                                 , jy   , jpi-ix+1)
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1, ix>=jpi//2+1), jy   , jpi-ix+1)
+
         if cd_type in [ 'F' ] :                              # F-point
-            (jy, ix) = modIJ (np.logical_and (jy==jpj  , ix<=jpi-1   ), jpj-2, jpi-ix  )
-            (jy, ix) = modIJ (np.logical_and (ix==jpj  , ix==jpi     ), jpj-2, 1       )
-            (jy, ix) = modIJ (np.logical_and (jy==jpj-1, ix>=jpi//2+1), jy   , jpi-ix  )
+            jy, ix = mod_ij (np.logical_and (jy==jpj  , ix<=jpi-1   ), jpj-2, jpi-ix  )
+            jy, ix = mod_ij (np.logical_and (ix==jpj  , ix==jpi     ), jpj-2, 1       )
+            jy, ix = mod_ij (np.logical_and (jy==jpj-1, ix>=jpi//2+1), jy   , jpi-ix  )
 
     ## Restore convention to Python/C : indexes start at 0
-    jy += -1 ; ix += -1
-
-    if isinstance (jj, int) : jy = jy.item ()
-    if isinstance (ii, int) : ix = ix.item ()
+    jy += -1
+    ix += -1
+
+    if isinstance (jj, int) :
+        jy = jy.item ()
+    if isinstance (ii, int) :
+        ix = ix.item ()
 
     return jy, ix
-    
-def geo2en (pxx, pyy, pzz, glam, gphi) : 
-    '''
-    Change vector from geocentric to east/north
+
+def find_ji (lat_data, lon_data, lat_grid, lon_grid, mask=1.0, verbose=False, out=None) :
+    '''
+    Description: seeks J,I indices of the grid point which is the closest
+       of a given point
+
+    Usage: go FindJI  <data latitude> <data longitude> <grid latitudes> <grid longitudes> [mask]
+    <grid latitudes><grid longitudes> are 2D fields on J/I (Y/X) dimensions
+    mask : if given, seek only non masked grid points (i.e with mask=1)
+
+    Example : findIJ (40, -20, nav_lat, nav_lon, mask=1.0)
+
+    Note : all longitudes and latitudes in degrees
+
+    Note : may work with 1D lon/lat (?)
+    '''
+    # Get grid dimensions
+    if len (lon_grid.shape) == 2 :
+        jpi = lon_grid.shape[-1]
+    else                         :
+        jpi = len(lon_grid)
+
+    #mmath = __mmath__ (lat_grid)
+
+    # Compute distance from the point to all grid points (in RADian)
+    arg      = ( np.sin (RAD*lat_data) * np.sin (RAD*lat_grid)
+               + np.cos (RAD*lat_data) * np.cos (RAD*lat_grid) *
+                 np.cos(RAD*(lon_data-lon_grid)) )
+    # Send masked points to 'infinite'
+    distance = np.arccos (arg) + 4.0*RPI*(1.0-mask)
+
+    # Truncates to alleviate some precision problem with some grids
+    prec = int (1E7)
+    distance = (distance*prec).astype(int) / prec
+
+    # Compute minimum of distance, and index of minimum
+    #
+    #distance_min = distance.min    ()
+    jimin        = int (distance.argmin ())
+
+    # Compute 2D indices (Python/C flavor : starting at 0)
+    jmin = jimin // jpi
+    imin = jimin - jmin*jpi
+
+    # Result
+    if verbose :
+        # Compute distance achieved
+        #mindist = distance [jmin, imin]
+
+        # Compute azimuth
+        dlon = lon_data-lon_grid[jmin,imin]
+        arg  = np.sin (RAD*dlon) / (
+                  np.cos(RAD*lat_data)*np.tan(RAD*lat_grid[jmin,imin])
+                - np.sin(RAD*lat_data)*np.cos(RAD*dlon))
+        azimuth = DAR*np.arctan (arg)
+        print ( f'I={imin:d} J={jmin:d} - Data:{lat_data:5.1f}Â°N {lon_data:5.1f}Â°E' \
+            +   f'- Grid:{lat_grid[jmin,imin]:4.1f}Â°N '   \
+            +   f'{lon_grid[jmin,imin]:4.1f}Â°E - Dist: {RA*distance[jmin,imin]:6.1f}km' \
+            +   f' {DAR*distance[jmin,imin]:5.2f}Â° ' \
+            +   f'- Azimuth: {RAD*azimuth:3.2f}RAD - {azimuth:5.1f}Â°' )
+
+    if   out=='dict'                     :
+        return {'x':imin, 'y':jmin}
+    elif out in ['array', 'numpy', 'np'] :
+        return np.array ( [jmin, imin] )
+    elif out in ['xarray', 'xr']         :
+        return xr.DataArray ( [jmin, imin] )
+    elif out=='list'                     :
+        return [jmin, imin]
+    elif out=='tuple'                    :
+        return jmin, imin
+    else                                 :
+        return jmin, imin
+
+def curl (tx, ty, e1f, e2f, nperio=None) :
+    '''Returns curl of a vector field
+    '''
+    ax = __find_axis__ (tx, 'x')[0]
+    ay = __find_axis__ (ty, 'y')[0]
+
+    tx_0  = lbc_add (tx , nperio=nperio, cd_type='U', psgn=-1)
+    ty_0  = lbc_add (ty , nperio=nperio, cd_type='V', psgn=-1)
+    e1f_0 = lbc_add (e1f, nperio=nperio, cd_type='U', psgn=-1)
+    e2f_0 = lbc_add (e2f, nperio=nperio, cd_type='V', psgn=-1)
+
+    tx_1  = tx_0.roll ( {ay:-1} )
+    ty_1  = ty_0.roll ( {ax:-1} )
+    tx_1  = lbc (tx_1, nperio=nperio, cd_type='U', psgn=-1)
+    ty_1  = lbc (ty_1, nperio=nperio, cd_type='V', psgn=-1)
+
+    zcurl = (ty_1 - ty_0)/e1f_0 - (tx_1 - tx_0)/e2f_0
+
+    mask = np.logical_or (
+             np.logical_or ( np.isnan(tx_0), np.isnan(tx_1)),
+             np.logical_or ( np.isnan(ty_0), np.isnan(ty_1)) )
+
+    zcurl = zcurl.where (np.logical_not (mask), np.nan)
+
+    zcurl = lbc_del (zcurl, nperio=nperio, cd_type='F', psgn=1)
+    zcurl = lbc (zcurl, nperio=nperio, cd_type='F', psgn=1)
+
+    return zcurl
+
+def div (ux, uy, e1t, e2t, nperio=None) :
+    '''Returns divergence of a vector field
+    '''
+    ax = __find_axis__ (ux, 'x')[0]
+    ay = __find_axis__ (ux, 'y')[0]
+
+    ux_0  = lbc_add (ux , nperio=nperio, cd_type='U', psgn=-1)
+    uy_0  = lbc_add (uy , nperio=nperio, cd_type='V', psgn=-1)
+    e1t_0 = lbc_add (e1t, nperio=nperio, cd_type='U', psgn=-1)
+    e2t_0 = lbc_add (e2t, nperio=nperio, cd_type='V', psgn=-1)
+
+    ux_1 = ux_0.roll ( {ay:1} )
+    uy_1 = uy_0.roll ( {ax:1} )
+    ux_1 = lbc (ux_1, nperio=nperio, cd_type='U', psgn=-1)
+    uy_1 = lbc (uy_1, nperio=nperio, cd_type='V', psgn=-1)
+
+    zdiv = (ux_0 - ux_1)/e2t_0 + (uy_0 - uy_1)/e1t_0
+
+    mask = np.logical_or (
+             np.logical_or ( np.isnan(ux_0), np.isnan(ux_1)),
+             np.logical_or ( np.isnan(uy_0), np.isnan(uy_1)) )
+
+    zdiv = zdiv.where (np.logical_not (mask), np.nan)
+
+    zdiv = lbc_del (zdiv, nperio=nperio, cd_type='T', psgn=1)
+    zdiv = lbc (zdiv, nperio=nperio, cd_type='T', psgn=1)
+
+    return zdiv
+
+def geo2en (pxx, pyy, pzz, glam, gphi) :
+    '''Change vector from geocentric to east/north
 
     Inputs :
@@ -960,9 +1400,9 @@
     '''
 
-    gsinlon = np.sin (rad * glam)
-    gcoslon = np.cos (rad * glam)
-    gsinlat = np.sin (rad * gphi)
-    gcoslat = np.cos (rad * gphi)
-          
+    gsinlon = np.sin (RAD * glam)
+    gcoslon = np.cos (RAD * glam)
+    gsinlat = np.sin (RAD * gphi)
+    gcoslat = np.cos (RAD * gphi)
+
     pte = - pxx * gsinlon            + pyy * gcoslon
     ptn = - pxx * gcoslon * gsinlat  - pyy * gsinlon * gsinlat + pzz * gcoslat
@@ -971,88 +1411,243 @@
 
 def en2geo (pte, ptn, glam, gphi) :
-    '''
-    Change vector from east/north to geocentric
-
-    Inputs : 
+    '''Change vector from east/north to geocentric
+
+    Inputs :
         pte, ptn   : eastward/northward components
         glam, gphi : longitude and latitude of the points
     '''
-    
-    gsinlon = np.sin (rad * glam)
-    gcoslon = np.cos (rad * glam)
-    gsinlat = np.sin (rad * gphi)
-    gcoslat = np.cos (rad * gphi)
+
+    gsinlon = np.sin (RAD * glam)
+    gcoslon = np.cos (RAD * glam)
+    gsinlat = np.sin (RAD * gphi)
+    gcoslat = np.cos (RAD * gphi)
 
     pxx = - pte * gsinlon - ptn * gcoslon * gsinlat
     pyy =   pte * gcoslon - ptn * gsinlon * gsinlat
     pzz =   ptn * gcoslat
-    
+
     return pxx, pyy, pzz
 
-def findJI (lat_data, lon_data, lat_grid, lon_grid, mask=1.0, verbose=False) :
-    '''
-    Description: seeks J,I indices of the grid point which is the closest of a given point 
-    Usage: go FindJI  <data latitude> <data longitude> <grid latitudes> <grid longitudes> [mask]
-    <longitude fields> <latitude field> are 2D fields on J/I (Y/X) dimensions
-    mask : if given, seek only non masked grid points (i.e with mask=1)
-    
-    Example : findIJ (40, -20, nav_lat, nav_lon, mask=1.0)
-
-    Note : all longitudes and latitudes in degrees
-        
-    Note : may work with 1D lon/lat (?)
-    '''
-    # Get grid dimensions
-    if len (lon_grid.shape) == 2 : (jpj, jpi) = lon_grid.shape
-    else                         : jpj = len(lat_grid) ; jpi=len(lon_grid)
-
-    mmath = __mmath__ (lat_grid)
-        
-    # Compute distance from the point to all grid points (in radian)
-    arg      = np.sin (rad*lat_data) * np.sin (rad*lat_grid) \
-             + np.cos (rad*lat_data) * np.cos (rad*lat_grid) * np.cos(rad*(lon_data-lon_grid))
-    distance = np.arccos (arg) + 4.0*rpi*(1.0-mask) # Send masked points to 'infinite' 
-
-    # Truncates to alleviate some precision problem with some grids
-    prec = int (1E7)
-    distance = (distance*prec).astype(int) / prec
-
-    # Compute minimum of distance, and index of minimum
-    #
-    distance_min = distance.min    ()
-    jimin        = int (distance.argmin ())
-    
-    # Compute 2D indices 
-    jmin = jimin // jpi ; imin = jimin - jmin*jpi
-
-    # Compute distance achieved
-    mindist = distance[jmin, imin]
-    
-    # Compute azimuth
-    dlon = lon_data-lon_grid[jmin,imin]
-    arg  = np.sin (rad*dlon) /  (np.cos(rad*lat_data)*np.tan(rad*lat_grid[jmin,imin]) - np.sin(rad*lat_data)*np.cos(rad*dlon))
-    azimuth = dar*np.arctan (arg)
-    
-    # Result
-    if verbose : 
-        print ('I={:d} J={:d} - Data:{:5.1f}Â°N {:5.1f}Â°E - Grid:{:4.1f}Â°N {:4.1f}Â°E - Dist: {:6.1f}km {:5.2f}Â° - Azimuth: {:3.2f}rad - {:5.1f}Â°'
-            .format (imin, jmin, lat_data, lon_data, lat_grid[jmin,imin], lon_grid[jmin,imin], ra*distance[jmin,imin], dar*distance[jmin,imin], rad*azimuth, azimuth))
-
-    return jmin, imin
-
-def clo_lon (lon, lon0) :
-    '''Choose closest to lon0 longitude, adding or substacting 360Â° if needed'''
+
+def clo_lon (lon, lon0=0., rad=False, deg=True) :
+    '''Choose closest to lon0 longitude, adding/substacting 360Â°
+    if needed
+    '''
     mmath = __mmath__ (lon, np)
-        
-    clo_lon = lon
-    clo_lon = mmath.where (clo_lon > lon0 + 180., clo_lon-360., clo_lon)
-    clo_lon = mmath.where (clo_lon < lon0 - 180., clo_lon+360., clo_lon)
-    clo_lon = mmath.where (clo_lon > lon0 + 180., clo_lon-360., clo_lon)
-    clo_lon = mmath.where (clo_lon < lon0 - 180., clo_lon+360., clo_lon)
-    if clo_lon.shape == () : clo_lon = clo_lon.item ()
-    return clo_lon
-
-def angle_full (glamt, gphit, glamu, gphiu, glamv, gphiv, glamf, gphif, nperio=None) :
-    '''Compute sinus and cosinus of model line direction with respect to east'''
+    if rad :
+        lon_range = 2.*np.pi
+    if deg :
+        lon_range = 360.
+    c_lon = lon
+    c_lon = mmath.where (c_lon > lon0 + lon_range*0.5,
+                             c_lon-lon_range, clo_lon)
+    c_lon = mmath.where (c_lon < lon0 - lon_range*0.5,
+                             c_lon+lon_range, clo_lon)
+    c_lon = mmath.where (c_lon > lon0 + lon_range*0.5,
+                             c_lon-lon_range, clo_lon)
+    c_lon = mmath.where (c_lon < lon0 - lon_range*0.5,
+                             c_lon+lon_range, clo_lon)
+    if c_lon.shape == () :
+        c_lon = c_lon.item ()
+    if mmath == xr :
+        if lon.attrs :
+            c_lon.attrs.update ( lon.attrs )
+    return c_lon
+
+def index2depth (pk, gdept_0) :
+    '''From index (real, continuous), get depth
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpk = gdept_0.shape[0]
+    kk = xr.DataArray(pk)
+    k  = np.maximum (0, np.minimum (jpk-1, kk    ))
+    k0 = np.floor (k).astype (int)
+    k1 = np.maximum (0, np.minimum (jpk-1,  k0+1))
+    zz = k - k0
+    gz = (1.0-zz)*gdept_0[k0]+ zz*gdept_0[k1]
+    return gz.values
+
+def depth2index (pz, gdept_0) :
+    '''From depth, get index (real, continuous)
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpk  = gdept_0.shape[0]
+    if   isinstance (pz, xr.core.dataarray.DataArray ) :
+        zz   = xr.DataArray (pz.values, dims=('zz',))
+    elif isinstance (pz,  np.ndarray) :
+        zz   = xr.DataArray (pz.ravel(), dims=('zz',))
+    else :
+        zz   = xr.DataArray (np.array([pz]).ravel(), dims=('zz',))
+    zz   = np.minimum (gdept_0[-1], np.maximum (0, zz))
+
+    idk1 = np.minimum ( (gdept_0-zz), 0.).argmax (axis=0).astype(int)
+    idk1 = np.maximum (0, np.minimum (jpk-1,  idk1  ))
+    idk2 = np.maximum (0, np.minimum (jpk-1,  idk1-1))
+
+    zff = (zz - gdept_0[idk2])/(gdept_0[idk1]-gdept_0[idk2])
+    idk = zff*idk1 + (1.0-zff)*idk2
+    idk = xr.where ( np.isnan(idk), idk1, idk)
+    return idk.values
+
+def index2depth_panels (pk, gdept_0, depth0, fact) :
+    '''From  index (real, continuous), get depth, with bottom part compressed
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpk = gdept_0.shape[0]
+    kk = xr.DataArray (pk)
+    k  = np.maximum (0, np.minimum (jpk-1, kk    ))
+    k0 = np.floor (k).astype (int)
+    k1 = np.maximum (0, np.minimum (jpk-1,  k0+1))
+    zz = k - k0
+    gz = (1.0-zz)*gdept_0[k0]+ zz*gdept_0[k1]
+    gz = xr.where ( gz<depth0, gz, depth0 + (gz-depth0)*fact)
+    return gz.values
+
+def depth2index_panels (pz, gdept_0, depth0, fact) :
+    '''From  index (real, continuous), get depth, with bottom part compressed
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpk = gdept_0.shape[0]
+    if isinstance (pz, xr.core.dataarray.DataArray) :
+        zz   = xr.DataArray (pz.values , dims=('zz',))
+    elif isinstance (pz, np.ndarray) :
+        zz   = xr.DataArray (pz.ravel(), dims=('zz',))
+    else :
+        zz   = xr.DataArray (np.array([pz]).ravel(), dims=('zz',))
+    zz         = np.minimum (gdept_0[-1], np.maximum (0, zz))
+    gdept_comp = xr.where ( gdept_0>depth0,
+                                (gdept_0-depth0)*fact+depth0, gdept_0)
+    zz_comp    = xr.where ( zz     >depth0, (zz     -depth0)*fact+depth0,
+                                zz     )
+    zz_comp    = np.minimum (gdept_comp[-1], np.maximum (0, zz_comp))
+
+    idk1 = np.minimum ( (gdept_0-zz_comp), 0.).argmax (axis=0).astype(int)
+    idk1 = np.maximum (0, np.minimum (jpk-1,  idk1  ))
+    idk2 = np.maximum (0, np.minimum (jpk-1,  idk1-1))
+
+    zff = (zz_comp - gdept_0[idk2])/(gdept_0[idk1]-gdept_0[idk2])
+    idk = zff*idk1 + (1.0-zff)*idk2
+    idk = xr.where ( np.isnan(idk), idk1, idk)
+    return idk.values
+
+def depth2comp (pz, depth0, fact ) :
+    '''Form depth, get compressed depth, with bottom part compressed
+
+    Needed to use transforms in Matplotlib
+    '''
+    #print ('start depth2comp')
+    if isinstance (pz, xr.core.dataarray.DataArray) :
+        zz   = pz.values
+    elif isinstance(pz, list) :
+        zz = np.array (pz)
+    else :
+        zz   = pz
+    gz = np.where ( zz>depth0, (zz-depth0)*fact+depth0, zz)
+    #print ( f'depth2comp : {gz=}' )
+    if type (pz) in [int, float] :
+        return gz.item()
+    else :
+        return gz
+
+def comp2depth (pz, depth0, fact ) :
+    '''Form compressed depth, get depth, with bottom part compressed
+
+    Needed to use transforms in Matplotlib
+    '''
+    if isinstance (pz, xr.core.dataarray.DataArray) :
+        zz   = pz.values
+    elif isinstance (pz, list) :
+        zz = np.array (pz)
+    else :
+        zz   = pz
+    gz = np.where ( zz>depth0, (zz-depth0)/fact+depth0, zz)
+    if type (pz) in [int, float] :
+        gz = gz.item()
+
+    return gz
+
+def index2lon (pi, plon_1d) :
+    '''From index (real, continuous), get longitude
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpi = plon_1d.shape[0]
+    ii = xr.DataArray (pi)
+    i =  np.maximum (0, np.minimum (jpi-1, ii    ))
+    i0 = np.floor (i).astype (int)
+    i1 = np.maximum (0, np.minimum (jpi-1,  i0+1))
+    xx = i - i0
+    gx = (1.0-xx)*plon_1d[i0]+ xx*plon_1d[i1]
+    return gx.values
+
+def lon2index (px, plon_1d) :
+    '''From longitude, get index (real, continuous)
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpi  = plon_1d.shape[0]
+    if isinstance (px, xr.core.dataarray.DataArray) :
+        xx   = xr.DataArray (px.values , dims=('xx',))
+    elif isinstance (px, np.ndarray) :
+        xx   = xr.DataArray (px.ravel(), dims=('xx',))
+    else :
+        xx   = xr.DataArray (np.array([px]).ravel(), dims=('xx',))
+    xx   = xr.where ( xx>plon_1d.max(), xx-360.0, xx)
+    xx   = xr.where ( xx<plon_1d.min(), xx+360.0, xx)
+    xx   = np.minimum (plon_1d.max(), np.maximum(xx, plon_1d.min() ))
+    idi1 = np.minimum ( (plon_1d-xx), 0.).argmax (axis=0).astype(int)
+    idi1 = np.maximum (0, np.minimum (jpi-1,  idi1  ))
+    idi2 = np.maximum (0, np.minimum (jpi-1,  idi1-1))
+
+    zff = (xx - plon_1d[idi2])/(plon_1d[idi1]-plon_1d[idi2])
+    idi = zff*idi1 + (1.0-zff)*idi2
+    idi = xr.where ( np.isnan(idi), idi1, idi)
+    return idi.values
+
+def index2lat (pj, plat_1d) :
+    '''From index (real, continuous), get latitude
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpj = plat_1d.shape[0]
+    jj  = xr.DataArray (pj)
+    j   = np.maximum (0, np.minimum (jpj-1, jj    ))
+    j0  = np.floor (j).astype (int)
+    j1  = np.maximum (0, np.minimum (jpj-1,  j0+1))
+    yy  = j - j0
+    gy  = (1.0-yy)*plat_1d[j0]+ yy*plat_1d[j1]
+    return gy.values
+
+def lat2index (py, plat_1d) :
+    '''From latitude, get index (real, continuous)
+
+    Needed to use transforms in Matplotlib
+    '''
+    jpj = plat_1d.shape[0]
+    if isinstance (py, xr.core.dataarray.DataArray) :
+        yy   = xr.DataArray (py.values , dims=('yy',))
+    elif isinstance (py, np.ndarray) :
+        yy   = xr.DataArray (py.ravel(), dims=('yy',))
+    else :
+        yy   = xr.DataArray (np.array([py]).ravel(), dims=('yy',))
+    yy   = np.minimum (plat_1d.max(), np.minimum(yy, plat_1d.max() ))
+    idj1 = np.minimum ( (plat_1d-yy), 0.).argmax (axis=0).astype(int)
+    idj1 = np.maximum (0, np.minimum (jpj-1,  idj1  ))
+    idj2 = np.maximum (0, np.minimum (jpj-1,  idj1-1))
+
+    zff = (yy - plat_1d[idj2])/(plat_1d[idj1]-plat_1d[idj2])
+    idj = zff*idj1 + (1.0-zff)*idj2
+    idj = xr.where ( np.isnan(idj), idj1, idj)
+    return idj.values
+
+def angle_full (glamt, gphit, glamu, gphiu, glamv, gphiv,
+                glamf, gphif, nperio=None) :
+    '''Computes sinus and cosinus of model line direction with
+    respect to east
+    '''
     mmath = __mmath__ (glamt)
 
@@ -1065,34 +1660,34 @@
     zlamf = lbc_add (glamf, nperio, 'F', 1.)
     zphif = lbc_add (gphif, nperio, 'F', 1.)
-    
+
     # north pole direction & modulous (at T-point)
-    zxnpt = 0. - 2.0 * np.cos (rad*zlamt) * np.tan (rpi/4.0 - rad*zphit/2.0)
-    zynpt = 0. - 2.0 * np.sin (rad*zlamt) * np.tan (rpi/4.0 - rad*zphit/2.0)
+    zxnpt = 0. - 2.0 * np.cos (RAD*zlamt) * np.tan (RPI/4.0 - RAD*zphit/2.0)
+    zynpt = 0. - 2.0 * np.sin (RAD*zlamt) * np.tan (RPI/4.0 - RAD*zphit/2.0)
     znnpt = zxnpt*zxnpt + zynpt*zynpt
-    
+
     # north pole direction & modulous (at U-point)
-    zxnpu = 0. - 2.0 * np.cos (rad*zlamu) * np.tan (rpi/4.0 - rad*zphiu/2.0)
-    zynpu = 0. - 2.0 * np.sin (rad*zlamu) * np.tan (rpi/4.0 - rad*zphiu/2.0)
+    zxnpu = 0. - 2.0 * np.cos (RAD*zlamu) * np.tan (RPI/4.0 - RAD*zphiu/2.0)
+    zynpu = 0. - 2.0 * np.sin (RAD*zlamu) * np.tan (RPI/4.0 - RAD*zphiu/2.0)
     znnpu = zxnpu*zxnpu + zynpu*zynpu
-    
+
     # north pole direction & modulous (at V-point)
-    zxnpv = 0. - 2.0 * np.cos (rad*zlamv) * np.tan (rpi/4.0 - rad*zphiv/2.0)
-    zynpv = 0. - 2.0 * np.sin (rad*zlamv) * np.tan (rpi/4.0 - rad*zphiv/2.0)
+    zxnpv = 0. - 2.0 * np.cos (RAD*zlamv) * np.tan (RPI/4.0 - RAD*zphiv/2.0)
+    zynpv = 0. - 2.0 * np.sin (RAD*zlamv) * np.tan (RPI/4.0 - RAD*zphiv/2.0)
     znnpv = zxnpv*zxnpv + zynpv*zynpv
 
     # north pole direction & modulous (at F-point)
-    zxnpf = 0. - 2.0 * np.cos( rad*zlamf ) * np.tan ( rpi/4. - rad*zphif/2. )
-    zynpf = 0. - 2.0 * np.sin( rad*zlamf ) * np.tan ( rpi/4. - rad*zphif/2. )
+    zxnpf = 0. - 2.0 * np.cos( RAD*zlamf ) * np.tan ( RPI/4. - RAD*zphif/2. )
+    zynpf = 0. - 2.0 * np.sin( RAD*zlamf ) * np.tan ( RPI/4. - RAD*zphif/2. )
     znnpf = zxnpf*zxnpf + zynpf*zynpf
 
     # j-direction: v-point segment direction (around T-point)
-    zlam = zlamv  
+    zlam = zlamv
     zphi = zphiv
     zlan = np.roll ( zlamv, axis=-2, shift=1)  # glamv (ji,jj-1)
     zphh = np.roll ( zphiv, axis=-2, shift=1)  # gphiv (ji,jj-1)
-    zxvvt =  2.0 * np.cos ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.cos ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
-    zyvvt =  2.0 * np.sin ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.sin ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
+    zxvvt =  2.0 * np.cos ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.cos ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
+    zyvvt =  2.0 * np.sin ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.sin ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
     znvvt = np.sqrt ( znnpt * ( zxvvt*zxvvt + zyvvt*zyvvt )  )
 
@@ -1102,54 +1697,46 @@
     zlan = np.roll (zlamf, axis=-2, shift=1) # glamf (ji,jj-1)
     zphh = np.roll (zphif, axis=-2, shift=1) # gphif (ji,jj-1)
-    zxffu =  2.0 * np.cos ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.cos ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
-    zyffu =  2.0 * np.sin ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.sin ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
+    zxffu =  2.0 * np.cos ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.cos ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
+    zyffu =  2.0 * np.sin ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.sin ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
     znffu = np.sqrt ( znnpu * ( zxffu*zxffu + zyffu*zyffu )  )
 
     # i-direction: f-point segment direction (around v-point)
-    zlam = zlamf  
+    zlam = zlamf
     zphi = zphif
     zlan = np.roll (zlamf, axis=-1, shift=1) # glamf (ji-1,jj)
     zphh = np.roll (zphif, axis=-1, shift=1) # gphif (ji-1,jj)
-    zxffv =  2.0 * np.cos ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.cos ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
-    zyffv =  2.0 * np.sin ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2.0 * np.sin ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
+    zxffv =  2.0 * np.cos ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.cos ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
+    zyffv =  2.0 * np.sin ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2.0 * np.sin ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
     znffv = np.sqrt ( znnpv * ( zxffv*zxffv + zyffv*zyffv )  )
 
     # j-direction: u-point segment direction (around f-point)
-    zlam = np.roll (zlamu, axis=-2, shift=-1) # glamu (ji,jj+1) 
+    zlam = np.roll (zlamu, axis=-2, shift=-1) # glamu (ji,jj+1)
     zphi = np.roll (zphiu, axis=-2, shift=-1) # gphiu (ji,jj+1)
     zlan = zlamu
     zphh = zphiu
-    zxuuf =  2. * np.cos ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2. * np.cos ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
-    zyuuf =  2. * np.sin ( rad*zlam ) * np.tan ( rpi/4. - rad*zphi/2. )   \
-          -  2. * np.sin ( rad*zlan ) * np.tan ( rpi/4. - rad*zphh/2. )
+    zxuuf =  2. * np.cos ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2. * np.cos ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
+    zyuuf =  2. * np.sin ( RAD*zlam ) * np.tan ( RPI/4. - RAD*zphi/2. ) \
+          -  2. * np.sin ( RAD*zlan ) * np.tan ( RPI/4. - RAD*zphh/2. )
     znuuf = np.sqrt ( znnpf * ( zxuuf*zxuuf + zyuuf*zyuuf )  )
 
-    
+
     # cosinus and sinus using scalar and vectorial products
     gsint = ( zxnpt*zyvvt - zynpt*zxvvt ) / znvvt
     gcost = ( zxnpt*zxvvt + zynpt*zyvvt ) / znvvt
-    
+
     gsinu = ( zxnpu*zyffu - zynpu*zxffu ) / znffu
     gcosu = ( zxnpu*zxffu + zynpu*zyffu ) / znffu
-    
+
     gsinf = ( zxnpf*zyuuf - zynpf*zxuuf ) / znuuf
     gcosf = ( zxnpf*zxuuf + zynpf*zyuuf ) / znuuf
-    
+
     gsinv = ( zxnpv*zxffv + zynpv*zyffv ) / znffv
-    gcosv =-( zxnpv*zyffv - zynpv*zxffv ) / znffv  # (caution, rotation of 90 degres)
-    
-    #gsint = lbc (gsint, cd_type='T', nperio=nperio, psgn=-1.)
-    #gcost = lbc (gcost, cd_type='T', nperio=nperio, psgn=-1.)
-    #gsinu = lbc (gsinu, cd_type='U', nperio=nperio, psgn=-1.)
-    #gcosu = lbc (gcosu, cd_type='U', nperio=nperio, psgn=-1.)
-    #gsinv = lbc (gsinv, cd_type='V', nperio=nperio, psgn=-1.)
-    #gcosv = lbc (gcosv, cd_type='V', nperio=nperio, psgn=-1.)
-    #gsinf = lbc (gsinf, cd_type='F', nperio=nperio, psgn=-1.)
-    #gcosf = lbc (gcosf, cd_type='F', nperio=nperio, psgn=-1.)
+    # (caution, rotation of 90 degres)
+    gcosv =-( zxnpv*zyffv - zynpv*zxffv ) / znffv
 
     gsint = lbc_del (gsint, cd_type='T', nperio=nperio, psgn=-1.)
@@ -1175,13 +1762,15 @@
 
 def angle (glam, gphi, nperio, cd_type='T') :
-    '''Compute sinus and cosinus of model line direction with respect to east'''
+    '''Computes sinus and cosinus of model line direction with
+    respect to east
+    '''
     mmath = __mmath__ (glam)
 
     zlam = lbc_add (glam, nperio, cd_type, 1.)
     zphi = lbc_add (gphi, nperio, cd_type, 1.)
-    
+
     # north pole direction & modulous
-    zxnp = 0. - 2.0 * np.cos (rad*zlam) * np.tan (rpi/4.0 - rad*zphi/2.0)
-    zynp = 0. - 2.0 * np.sin (rad*zlam) * np.tan (rpi/4.0 - rad*zphi/2.0)
+    zxnp = 0. - 2.0 * np.cos (RAD*zlam) * np.tan (RPI/4.0 - RAD*zphi/2.0)
+    zynp = 0. - 2.0 * np.sin (RAD*zlam) * np.tan (RPI/4.0 - RAD*zphi/2.0)
     znnp = zxnp*zxnp + zynp*zynp
 
@@ -1191,11 +1780,11 @@
     zlan_s = np.roll (zlam, axis=-2, shift= 1) # glam [jj-1, ji]
     zphh_s = np.roll (zphi, axis=-2, shift= 1) # gphi [jj-1, ji]
-    
-    zxff = 2.0 * np.cos (rad*zlan_n) * np.tan (rpi/4.0 - rad*zphh_n/2.0) \
-        -  2.0 * np.cos (rad*zlan_s) * np.tan (rpi/4.0 - rad*zphh_s/2.0)
-    zyff = 2.0 * np.sin (rad*zlan_n) * np.tan (rpi/4.0 - rad*zphh_n/2.0) \
-        -  2.0 * np.sin (rad*zlan_s) * np.tan (rpi/4.0 - rad*zphh_s/2.0)
+
+    zxff = 2.0 * np.cos (RAD*zlan_n) * np.tan (RPI/4.0 - RAD*zphh_n/2.0) \
+        -  2.0 * np.cos (RAD*zlan_s) * np.tan (RPI/4.0 - RAD*zphh_s/2.0)
+    zyff = 2.0 * np.sin (RAD*zlan_n) * np.tan (RPI/4.0 - RAD*zphh_n/2.0) \
+        -  2.0 * np.sin (RAD*zlan_s) * np.tan (RPI/4.0 - RAD*zphh_s/2.0)
     znff = np.sqrt (znnp * (zxff*zxff + zyff*zyff) )
- 
+
     gsin = (zxnp*zyff - zynp*zxff) / znff
     gcos = (zxnp*zxff + zynp*zyff) / znff
